
Ruby - Bug #2760

unable to cross-compile win32.c

02/19/2010 04:43 AM - rogerdpack (Roger Pack)

Status: Rejected   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version:    

ruby -v: Revision: 26711 Backport:  

Description

=begin

:~/ruby_trunk$ gcc win32/win32.c 2>&1 | grep lvalue

win32/win32.c:4894: error: lvalue required as left operand of assignment

win32/win32.c:5016: error: lvalue required as left operand of assignment

This seems to help:

Index: win32/win32.c

--- win32/win32.c       (revision 26711)

+++ win32/win32.c       (working copy)

@@ -4891,7 +4891,7 @@

}

     if (pol) {

      wait = rb_w32_wait_events_blocking(&ol.hEvent, 1, INFINITE);

      wait = (DWORD) rb_w32_wait_events_blocking(&ol.hEvent, 1, INFINITE);

      if (wait != WAIT_OBJECT_0) {

          if (wait == WAIT_OBJECT_0 + 1)

              errno = EINTR;

@@ -5013,7 +5013,7 @@

}

     if (pol) {

      wait = rb_w32_wait_events_blocking(&ol.hEvent, 1, INFINITE);

      wait = (DWORD) rb_w32_wait_events_blocking(&ol.hEvent, 1, INFINITE);

      if (wait != WAIT_OBJECT_0) {

          if (wait == WAIT_OBJECT_0 + 1)

              errno = EINTR;

=end

History

#1 - 02/19/2010 12:46 PM - naruse (Yui NARUSE)

- Category set to core

- Status changed from Open to Assigned

- Assignee set to usa (Usaku NAKAMURA)

=begin
=end

#2 - 02/19/2010 01:15 PM - nobu (Nobuyoshi Nakada)

- Assignee changed from usa (Usaku NAKAMURA) to nobu (Nobuyoshi Nakada)

=begin

I don't see such errors with i386-mingw32-gcc on darwin.

gcc -v shows:

$ i386-mingw32-gcc -v

Reading specs from /opt/local/lib/gcc/i386-mingw32/3.4.5/specs

Configured with:

/opt/local/var/macports/build/_opt_local_var_macports_sources_rsync.macports.org_release_ports_cross_i386-mingw32-gcc/work/gcc-3.4.5-2006011

7-1/configure --prefix=/opt/local --infodir=/opt/local/share/info --mandir=/opt/local/share/man --target=i386-mingw32 --without-newlib --disable-nls

--with-gnu-as --with-gnu-ld --disable-multilib --with-gxx-include-dir=/opt/local/i386-mingw32/include/c++/3.4.5/

Thread model: single

gcc version 3.4.5 (mingw special)

It feels like wait macro is defined.  What does this show?

gcc -E win32/win32.c | fgrep '= rb_w32_wait_events_blocking'

=end

#3 - 02/23/2010 08:02 PM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Feedback

=begin

=end

#4 - 04/20/2010 09:29 PM - mame (Yusuke Endoh)

=begin

Hi, Roger

Could you answer to nobu?

--

Yusuke Endoh mame@tsg.ne.jp

=end

#5 - 04/21/2010 05:04 AM - rogerdpack (Roger Pack)

=begin

ruby_trunk$ gcc -Iinclude -E win32/win32.c 2>&1 | fgrep '= rb_w32_wait_events_blocking'

ret = rb_w32_wait_events_blocking(events, count, timeout);

wait = rb_w32_wait_events_blocking(&ol.hEvent, 1, INFINITE);

wait = rb_w32_wait_events_blocking(&ol.hEvent, 1, INFINITE);

ruby_trunk$ i586-mingw32msvc-gcc win32/win32.c  2>&1 | grep lvalue

win32/win32.c:4320: error: lvalue required as decrement operand

win32/win32.c:4321: error: lvalue required as increment operand

win32/win32.c:4340: error: lvalue required as decrement operand

win32/win32.c:4341: error: lvalue required as increment operand

Unfortunately I didn't actually try cross-compiling (just compiling), so it's possible that this is not a real problem.  Hope to do a real build this weekend.

-rp

=end

#6 - 04/21/2010 09:41 PM - luislavena (Luis Lavena)

=begin

I can confirm that up to latest revision (r27432) trunk is cross compilable with GCC 3.4.5 (mingw32 from macports)

--

Luis Lavena

=end

#7 - 05/30/2010 02:41 AM - mame (Yusuke Endoh)

=begin
Hi, Roger

Any update here?

--

Yusuke Endoh mame@tsg.ne.jp

=end

#8 - 06/04/2010 02:24 AM - rogerdpack (Roger Pack)

- Status changed from Feedback to Rejected

=begin

=end

Powered by TCPDF (www.tcpdf.org)

06/21/2025 3/3

mailto:mame@tsg.ne.jp
http://www.tcpdf.org

